new;
library Mlib;

output file = mlib1.out reset;

fn fexp(x) = exp(x);
fn fcos(x) = cos(x);
fn fsin(x) = sin(x);

x = rndn(4,4);

A = expMatrix(x);
B = real(fnMatrix(x,&fexp));
C = cosMatrix(x);
D = real(fnMatrix(x,&fcos));
E = sinMatrix(x);
F = real(fnMatrix(x,&fsin));

print "x = " x;
print "expMatrix(x) = " A;
print "fnMatrix(x,exp) = " B;
print "cosMatrix(x) = " C;
print "fnMatrix(x,cos) = " D;
print "sinMatrix(x) = " E;
print "fnMatrix(x,sin) = " F;

x = rndn(2,2) + sqrt(-1)*rndn(2,2);
A = expMatrix(x);
B = cosMatrix(x);
C = sinMatrix(x);

print "x = " x;
print "expMatrix(x) = " A;
print "cosMatrix(x) = " B;
print "sinMatrix(x) = " C;

/* cos(x)^2 + sin(x)^2 = I */

D = B*B + C*C;

print "cos(x)^2 + sin(x)^2 = " D;

output off;