new;
library Mlib;

Nobs = 300;

a = rndn(Nobs,1); b = rndn(Nobs,1); c = rndn(Nobs,1);
X = TDGmatrix_to_Dmatrix(a,b,c);
d = X*seqa(1,1,Nobs);

format 8,4;

t0 = hsec;
y1 = TDGsolve(a,b,c,d);
t1 = hsec;
y2 = d/X;
t2 = hsec;

print ftos((t1-t0)/100,"Computation time (TDGsolve): %lf seconds",10,2);
print ftos((t2-t1)/100,"Computation time (LU): %lf seconds",10,2);


t0 = hsec;
invX1 = invTDGmatrix(a,b,c);
t1 = hsec;
invX2 = inv(X);
t2 = hsec;

print ftos((t1-t0)/100,"Computation time (invTDGmatrix): %lf seconds",10,2);
print ftos((t2-t1)/100,"Computation time (inv): %lf seconds",10,2);
